Skip to content
For the complete documentation index, see llms.txt. Markdown versions of documentation pages are available by appending .md to the page URL.
Primary navigation
Theme

Create Platform workload identity provider

POST
/organization/workload_identity_providers

Register an OIDC provider for keyless project service-account authentication.

Create Platform workload identity provider

curl -X POST "https://api.openai.com/v1/organization/workload_identity_providers" \
  -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
  -H "Content-Type: application/json" \
  -d '{
  "name": "CI provider",
  "type": "oidc",
  "issuer": "https://issuer.example.com",
  "audience": "openai"
}'
Response example
{
  "object": "organization.workload_identity_provider",
  "id": "wip_example",
  "type": "oidc",
  "name": "CI provider",
  "issuer": "https://issuer.example.com",
  "audience": "openai",
  "verification": {
    "type": "discovery",
    "discovery_url": null
  },
  "description": null,
  "attribute_transformations": [],
  "enabled": true,
  "created_at": 1793664000,
  "updated_at": 1793664000
}
Body Parameters
JSON
audience: string
minLength1
issuer: string
minLength1
name: string
minLength1
type: "oidc" (default: "oidc")
attribute_transformations: optional array of object { attribute, expression }
maxItems20
attribute: string
minLength1
maxLength256
expression: string
minLength1
maxLength4096
description: optional string
enabled: optional boolean
verification: optional DiscoveryVerificationParam { discovery_url, type } or UploadedJwksVerificationParam { jwks, type }
One of the following:
DiscoveryVerificationParam object { discovery_url, type }
discovery_url: string or null
type: "discovery" (default: "discovery")
UploadedJwksVerificationParam object { jwks, type }
jwks: map[unknown]
type: "uploaded_jwks" (default: "uploaded_jwks")
Returns
WorkloadIdentityProvider object { id, attribute_transformations, audience, 9 more }
id: string
attribute_transformations: array of object { attribute, expression }
attribute: string
expression: string
audience: string
created_at: integer
description: string or null
enabled: boolean
issuer: string
name: string
object: "organization.workload_identity_provider" (default: "organization.workload_identity_provider")
type: "oidc" (default: "oidc")
updated_at: integer
verification: DiscoveryVerification { discovery_url, type } or UploadedJwksVerification { jwks, type }
One of the following:
DiscoveryVerification object { discovery_url, type }
discovery_url: string or null
type: "discovery" (default: "discovery")
UploadedJwksVerification object { jwks, type }
jwks: map[unknown]
type: "uploaded_jwks" (default: "uploaded_jwks")
Returns Examples
Response example
{
  "object": "organization.workload_identity_provider",
  "id": "wip_example",
  "type": "oidc",
  "name": "CI provider",
  "issuer": "https://issuer.example.com",
  "audience": "openai",
  "verification": {
    "type": "discovery",
    "discovery_url": null
  },
  "description": null,
  "attribute_transformations": [],
  "enabled": true,
  "created_at": 1793664000,
  "updated_at": 1793664000
}